IdealConsolidator Class Reference

`#include <IdealConsolidator.h>`

Inheritance diagram for IdealConsolidator:

## Public Member Functions

| IdealConsolidator (unique_ptr< BigTermConsumer > consumer)
virtual void | beginConsumingList ()
| Tell the consumer that the ideals that are consumed until the next call to doneConsumingList are to be considered as one list of ideals, rather than as a number of separate ideals.
virtual void | consumeRing (const VarNames &names)
| Tell the consumer which ring is being used.
virtual void | beginConsuming ()
| Tell the consumer to begin consuming an ideal.
virtual void | consume (const Term &term)
| Consume a term.
virtual void | consume (const Term &term, const TermTranslator &translator)
virtual void | consume (const vector< mpz_class > &term)
virtual void | doneConsuming ()
| Must be called once after each time beginConsuming has been called.
virtual void | consume (const BigIdeal &ideal)
virtual void | doneConsumingList ()
| Must be called once after each time beginConsumingList has been called.
Public Member Functions inherited from BigTermConsumer
virtual | ~BigTermConsumer ()
virtual void | consume (unique_ptr< BigIdeal > ideal)
void | beginConsuming (const VarNames &names)
Public Member Functions inherited from TermConsumer
virtual | ~TermConsumer ()
void | consume (const Ideal &ideal)
| This is a non-virtual utility method that calls the other methods to achieve its effect of calling beginConsuming, then consuming all generators, and then calling doneConsuming.

## Private Attributes

const unique_ptr< BigTermConsumer > | _consumer
BigIdeal | _ideal
VarNames | _names
bool | _inList
bool | _inIdeal
vector< mpz_class > | _tmp

## Detailed Description

Definition at line 29 of file IdealConsolidator.h.

## Constructor & Destructor Documentation

## IdealConsolidator()

IdealConsolidator::IdealConsolidator | ( | unique_ptr< BigTermConsumer > | consumer | ) |

Definition at line 23 of file IdealConsolidator.cpp.

## Member Function Documentation

## beginConsuming()

void IdealConsolidator::beginConsuming | ( |  | ) |

virtual

Tell the consumer to begin consuming an ideal.

It is required to call this method before calling consume().

Implements BigTermConsumer.

Definition at line 47 of file IdealConsolidator.cpp.

## beginConsumingList()

void IdealConsolidator::beginConsumingList | ( |  | ) |

virtual

Tell the consumer that the ideals that are consumed until the next call to doneConsumingList are to be considered as one list of ideals, rather than as a number of separate ideals.

The default implementation is to ignore this, but the consumer is free to do something special in this case. It is thus not in general required to call this method, but if you don't, make sure that every consumer that you want to use does what you want if you output more than a single ideal.

Reimplemented from TermConsumer.

Definition at line 39 of file IdealConsolidator.cpp.

## consume() [1/4]

void IdealConsolidator::consume | ( | const BigIdeal & | ideal | ) |

virtual

Reimplemented from BigTermConsumer.

Definition at line 90 of file IdealConsolidator.cpp.

## consume() [2/4]

void IdealConsolidator::consume | ( | const Term & | term | ) |

virtual

Consume a term.

Reimplemented from BigTermConsumer.

Definition at line 52 of file IdealConsolidator.cpp.

## consume() [3/4]

void IdealConsolidator::consume | ( | const Term & | term,
|  | const TermTranslator & | translator )

virtual

Implements BigTermConsumer.

Definition at line 60 of file IdealConsolidator.cpp.

## consume() [4/4]

void IdealConsolidator::consume | ( | const vector< mpz_class > & | term | ) |

virtual

Implements BigTermConsumer.

Definition at line 69 of file IdealConsolidator.cpp.

## consumeRing()

void IdealConsolidator::consumeRing | ( | const VarNames & | names | ) |

virtual

Tell the consumer which ring is being used.

Implements BigTermConsumer.

Definition at line 29 of file IdealConsolidator.cpp.

## doneConsuming()

void IdealConsolidator::doneConsuming | ( |  | ) |

virtual

Must be called once after each time beginConsuming has been called.

Implements BigTermConsumer.

Definition at line 76 of file IdealConsolidator.cpp.

## doneConsumingList()

void IdealConsolidator::doneConsumingList | ( |  | ) |

virtual

Must be called once after each time beginConsumingList has been called.

Reimplemented from TermConsumer.

Definition at line 84 of file IdealConsolidator.cpp.

## Member Data Documentation

## _consumer

const unique_ptr<BigTermConsumer> IdealConsolidator::_consumer

private

Definition at line 47 of file IdealConsolidator.h.

## _ideal

BigIdeal IdealConsolidator::_ideal

private

Definition at line 48 of file IdealConsolidator.h.

## _inIdeal

bool IdealConsolidator::_inIdeal

private

Definition at line 51 of file IdealConsolidator.h.

## _inList

bool IdealConsolidator::_inList

private

Definition at line 50 of file IdealConsolidator.h.

## _names

VarNames IdealConsolidator::_names

private

Definition at line 49 of file IdealConsolidator.h.

## _tmp

vector<mpz_class> IdealConsolidator::_tmp

private

Definition at line 52 of file IdealConsolidator.h.

The documentation for this class was generated from the following files:

- src/IdealConsolidator.h
- src/IdealConsolidator.cpp